#!/bin/sh
# make WaveTomography for system determined by lscpu

export CC=g++ EXENAME=wavetm

if echo '#include <CL/cl.h>' | g++ -c -x c++ -  
then
echo GPU support enabled
export GPU=-DTARGET_GPU
export LFLAGS1='-L /opt/cuda/cuda-11.1/lib64 -lOpenCL'
export BINS='gpu.h k2d.cl'
fi

if  lscpu | grep -q avx512
then
echo Building for AVX512 CPU
export CCOPT1='-mavx512f -mavx512bw -mavx512dq -mavx2  -mfma  -msse2avx' 

elif lscpu | grep -q aarch64
then
echo Building for Kunpeng-920
export ARM='-DTARGET_ARM' CCOPT1='-march=armv8.2-a' 
 
else
echo Building for generic Intel AVX2 CPU
export CCOPT1='-DTARGET_GPU -mavx2 -mfma -msse2avx' 
fi

make -B 

if  mpicxx --version
then 
echo Building MPI version
export CC=mpicxx MPI=-DUSE_MPI EXENAME=wavetm_mpi 
make -B 
fi
