// Makes vector type declarations the same in ARM and Intel/OpenCL environments

#pragma once

#ifdef ARM_INTRINSICS
#include <arm_neon.h>
typedef float32x4_t float4;
typedef uint32x4_t uint4;
typedef int32x4_t int4;
typedef int16x8_t short8;
#else
typedef float float4 __attribute__((vector_size(16)));
typedef cl_int int4 __attribute__((vector_size(16)));
typedef cl_uint uint4 __attribute__((vector_size(16)));
typedef cl_short short8 __attribute__((vector_size(16)));
#endif

typedef float float2 __attribute__((vector_size(8)));
typedef float float8 __attribute__((vector_size(32)));
typedef float float16 __attribute__((vector_size(64)));

typedef cl_int int2 __attribute__((vector_size(8)));
typedef cl_int int8 __attribute__((vector_size(32)));
typedef cl_int int16 __attribute__((vector_size(64)));

typedef cl_uint uint2 __attribute__((vector_size(8)));
typedef cl_uint uint8 __attribute__((vector_size(32)));
typedef cl_uint uint16 __attribute__((vector_size(64)));
