
// THIS FILE IS INCLUDED IN BOTH C++ AND OpenCL

#ifndef _GPU_H_
#define _GPU_H_

#define MAX_SRCS 256
#define DTCTR_ALIGN 32 
// should be accessible from OpenCL, so no constexpr

#ifdef __OPENCL_VERSION__
// make c++ types accessible from OpenCL
typedef unsigned int cl_uint;
typedef int4    cl_int4;
typedef int     cl_int;
typedef uint4   cl_uint4;
typedef float   cl_float;
typedef float2  cl_float2;
typedef float4  cl_float4;
typedef float8  cl_float8;
typedef float16 cl_float16;
typedef ulong   cl_ulong;
typedef ulong2  cl_ulong2;
typedef ulong4  cl_ulong4;
typedef long    cl_long;
typedef long4   cl_long4;
#endif

typedef struct tagCONST_DATA
{
	cl_float8 LAPL;
	cl_ulong2 pgLU, pgLW;
	cl_ulong pgGrad, pgParGrad, pgCoeff;

	cl_float2 GradScale, ParGradScale;

	cl_ulong DY, DZ;
	cl_uint InW, InH, FullW, FullH,	InOffsetB, GPUSrcs;

	cl_uint NumDetectors, NumBoundary, NumDetectorsA, NumBoundaryA,		NFrames;

	float Kuh, Kdl, Kdh, Kmid, Kdif; // boundary condition coefficients
	
	float dx, dt, Vel, CScale, AScale;
	
	float ImpStart, ImpWidth, ImpFreq,
		ImpClipAMin, ImpClipAMax,
		EndInvTime, GradMixDuration, EndTFade , _rsvd_;

	cl_float2 SrcPos[MAX_SRCS];

} CONST_DATA;


#endif // #ifndef _GPU_H_
