#pragma once
#include "shaderobj.h"

struct Parallel
{
	ShaderObj *pObj; cl_ulong Arg;
	cl_uint Width, Height, CellX, CellY, DY, Mode;

	cl_uint el_wid, nRuns;
	cl_ulong TimeSpent, MaxTime, MinTime;

	static constexpr int RUN_1D = 0, RUN_2D_YMARCH = 1, RUN_TASK_SINGLE = 2, RUN_TASK_ALL = 3,
		RUN_MASK = 0x7F, RUN_HYPER = 0x100, RUN_HYPER2 = 0x200,  RUN_ASYNC=0x400, RUN_PRINT = 0x1000, RUN_LAST_ITEM = 0x8000;

	inline Parallel() 	{	memset(this, 0, sizeof(*this));	}

	inline Parallel(ShaderObj* pO, cl_ulong A, cl_uint W, cl_uint H, cl_uint CX, cl_uint CY, cl_uint D, cl_uint M)
	{
		pObj = pO; Arg = A; Width = W; Height = H; CellX = CX; CellY = CY; DY = D; Mode = M;
		ResetOne();
	}

	void ResetOne(void);
	int Reset(void);
	int Print(int level=1);
	int Run(int RunMethod, int T0, int NSteps);

};// struct



