#pragma once
#include <cstdio>
typedef void(*ShaderFn)(cl_ulong, cl_ulong, int, int, int, int);

struct ShaderObj
{
	static constexpr
		int FL_1D = 1, FL_2D = 2, FL_INTEL = 0x100, FL_ARM = 0x200;
	
	static ShaderObj* ShaderBase;
	static int ActiveArch;

	char Name[16];
	int el_wid, Y_gran, flags, rsvd;
	ShaderFn pF;
	ShaderObj* pNext;

	ShaderObj(const char* nm, int w, int fl, ShaderFn F, int Yg = 1);

	void Print() const
	{ printf("\n %16s w=%2i g=%i %06X ", Name, el_wid, Y_gran, flags); }

	int PrintAll() const;
	
};

ShaderObj* GetShader(const char* name, int Flags_Req, int Flags_opt = 0, int width_req = 0);





