#include "setup.h"
#define LOAD_CA(AAu)	CC=vcvtq_n_f32_u32(CCu=vshlq_n_u32(AAu,16),(32-CData::C_SCALE_BITS));	CC*=CC; \
	AA=vcvtq_n_f32_u32(AAu=vshrq_n_u32(AAu,16),(16-CData::A_SCALE_BITS));
//-end-macro


SHADER(BackwardWave, 4, 5)
{
	regs float4 U0A, U1A, U2A, U0B, U1B, U2B, U0C, U1C, U2C, U0D, U1D, U2D, U0E, U1E, U2E;
	regs float4 W0A, W1A, W2A, W0B, W1B, W2B, W0C, W1C, W2C, W0D, W1D, W2D, W0E, W1E, W2E;
	const float LAP0 = CD->LAPL.s[0];
	const cl_ulong DY = CD->DY;

	float GradMix = (T - CD->EndInvTime) / CD->GradMixDuration; 
	GradMix = CLAMP(GradMix, 0.0f, 1.0f); 
	const float CGScale = CD->CGScale*GradMix, AGScale = CD->AGScale*GradMix; 

	int O, Src = 0; cl_ulong SOffs = 0;
	for ( Src = 0; Src < CD->ActiveSrcs; ++Src, SOffs += CD->DZ )
	{
		int HH = H; cl_ulong offs0 = offset;

		for ( O = (HH >> 16), HH &= 0xFFFF; O >= 0; offs0 += 4 * 4, --O )
		{


#ifdef TARGET_ARM
			union { float4 f; uint4 u; } CCx, AAx;
#define AA AAx.f
#define AAu AAx.u
#define CC CCx.f
#define CCu CCx.u
//#define add_saturated vqaddq
//#define roundi vcvtnq_s32_f32

#define COMPUTEGRAD(_A) { int4 T=vdupq_n_s32(0x7FFF); *(short8*)(GData) = vqaddq_s16( *(short8*)(GData),  \
				  vreinterpretq_s16_s32( vorrq_s32 (vandq_s32( vqaddq_s32(vcvtnq_s32_f32(W1##_A),T),vdupq_n_s32(0xFFFF0000)), \
				   vreinterpretq_s32_u32(vshrq_n_u32(vreinterpretq_u32_s32(vqaddq_s32(vcvtnq_s32_f32(U1##_A),T)),16) ) ) ) ); }
//-end-macro

#else
			float4 CC, AA; uint4 CCu, AAu; // vectorclass doesn't allow union. Defined to test ARM functions on Intel CPU.
			#define COMPUTEGRAD_lowbit(_A) add_saturated(*(short8*)(GData), (short8)(  (roundi(U1##_A)&0x0FFFF) | (roundi(W1##_A) << 16))).store_a((short8*)GData); 
      #define COMPUTEGRAD(_A) add_saturated(*(short8*)(GData), (short8)(  (int4)((uint4)roundi(U1##_A)>>16) | (roundi(W1##_A)&0xFFFF0000))).store_a((short8*)GData); 
#endif
			
			cl_ulong pCoeff = CD->pCoeff + offs0, GOffs = CD->pGrad - CD->pCoeff;
			
			SET_UADDR(WOffs, ZOffs);
			SET_WADDR(UOffs, VOffs);

			UOffs = SOffs + (UOffs - CD->pCoeff - DY - DY - 8),
				VOffs = SOffs + (VOffs - CD->pCoeff);
			WOffs = SOffs + (WOffs - CD->pCoeff - DY - DY - 8);
			ZOffs = SOffs + (ZOffs - CD->pCoeff);


#define UOld   (pCoeff+VOffs)
#define UData  (pCoeff+UOffs)
#define WOld   (pCoeff+ZOffs)
#define WData  (pCoeff+WOffs)
#define GData  (pCoeff+GOffs)

#define LOADLINE(pp,qq,E) {  \
	LDPair_(U2##E,CC, (float*)pp);  /* V2:CC = a  b  A  B : C  D  E  F  */   \
	LDPair_(W2##E,AA, (float*)qq);   \
	prefetch((pp)+DY); prefetch((qq)+DY); \
	U0##E=vextq<1>(U2##E,CC); U1##E=vextq<3>(U2##E,CC); \
	W0##E=vextq<1>(W2##E,AA); W1##E=vextq<3>(W2##E,AA); \
  U1##E+=U0##E; W1##E+=W0##E;  /* V1 = bB aC BD CE  */ \
  U0##E=vextq<2>(U2##E,CC); W0##E=vextq<2>(W2##E,AA); /* V0 = A B C D */ \
	U2##E += CC; W2##E += AA;  } /* V2 = aC bD AE BF  */
//-end-macro

#define PROCESS(_A,_B,_C,_D,_E)	{   LOADLINE(UData,  WData, _E); \
 CC=*(float4*)(CD->LAPL.s);  AA=((float4*)(CD->LAPL.s))[1]; /* LDPair(CC,AA,CD->LAPL); */\
  /*AA=*(float4*)(CD->LAPL+4);*/ \
	 /*prefetch(pCoeff); prefetch(pCoeff+VOffs); */ \
  U0##_A=fmul<3>( (U0##_A + U0##_E + U2##_C), CC); \
	W0##_A=fmul<3>( (W0##_A + W0##_E + W2##_C), CC); \
	U0##_A=acc_mul<1>(U0##_A,(U2##_A + U2##_E), AA);\
	W0##_A=acc_mul<1>(W0##_A,(W2##_A + W2##_E), AA);/* U0,W0.##_A=LAPL  36 flops */\
	U2##_A=fmul<1>((U1##_C + U0##_B + U0##_D), CC);\
	W2##_A=fmul<1>((W1##_C + W0##_B + W0##_D), CC);\
	U0##_A=acc_mul<0>(U0##_A, (U1##_A + U1##_E + U2##_B + U2##_D), AA);\
	W0##_A=acc_mul<0>(W0##_A, (W1##_A + W1##_E + W2##_B + W2##_D), AA);\
	U2##_A=acc_mul<2>(U2##_A, (U1##_B + U1##_D), CC);\
	W2##_A=acc_mul<2>(W2##_A, (W1##_B + W1##_D), CC); /* 20 flops */\
	U0##_A+=U2##_A; W0##_A+=W2##_A; /* UW.0A = LAPL_SUM */ \
	/* Load coefficients */ \
	W2##_A=vdupq_n_f32(LAP0);  \
	AAu=*(uint4*)pCoeff;	 LOAD_CA(AAu); \
	U1##_A=CC+AA; AA=CC-AA; (CC+=CC)+=W2##_A; \
	\
	U0##_A=acc_mul(U0##_A, U0##_C,CC); /* 40 flops */ \
  W0##_A=acc_mul(W0##_A, W0##_C,CC); /* 40 flops */ \
  U2##_A=*(float4*)(UOld); \
	W2##_A=*(float4*)(WOld); \
	U0##_A=nacc_mul(U0##_A,  AA,    U2##_A); /* 42 flops */ \
  W0##_A=nacc_mul(W0##_A,  U1##_A, W2##_A); /* 42 flops */ \
  *(float4*)(UOld)=(U0##_A /= U1##_A); /* U0 free */ \
	*(float4*)(WOld)=(W0##_A /= AA    ); /* U0 free */ \
  U1##_A=(W0##_C-W0##_A)*(U0##_C-U0##_A)*CGScale; \
  W1##_A=(W0##_C)*(U2##_A-U0##_A)*AGScale; \
	COMPUTEGRAD(_A);  pCoeff += DY;	  }
//-end-macro

			LOADLINE(UData, WData, A); UOffs += DY; WOffs += DY;
			LOADLINE(UData, WData, B); UOffs += DY; WOffs += DY;
			LOADLINE(UData, WData, C); UOffs += DY; WOffs += DY;
			LOADLINE(UData, WData, D); UOffs += DY; WOffs += DY;
			for ( int Y = HH; Y > 0; Y -= 5 )
			{
				PROCESS(A, B, C, D, E);
				PROCESS(B, C, D, E, A);
				PROCESS(C, D, E, A, B);
				PROCESS(D, E, A, B, C);
				PROCESS(E, A, B, C, D);
			}// vert

		}// offs loop
	}// src loop
} // fn

#undef LOADLINE
#undef PROCESS
#undef UOld
#undef UData

SHADER(ForwardWave, 8, 5)
{
#define FWDDECL	regs float4 U0A, U1A, U2A, U0B, U1B, U2B, U0C, U1C, U2C, U0D, U1D, U2D, U0E, U1E, U2E;\
	regs float4 W0A, W1A, W2A, W0B, W1B, W2B, W0C, W1C, W2C, W0D, W1D, W2D, W0E, W1E, W2E; \
	const float LAP0 = CD->LAPL.s[0];	const cl_ulong DY = CD->DY;\
//-end-macro

	FWDDECL


#ifdef TARGET_ARM
		union { float4 f; uint4 u; } CCx, AAx;
#else
		float4 CC, AA; uint4 CCu, AAu;
#endif

	int O, Src = 0; cl_ulong SOffs = 0;
	for ( Src = 0; Src < CD->ActiveSrcs; ++Src, SOffs += CD->DZ )
	{
		int HH = H; cl_ulong offs0 = offset;
		for ( O = (HH >> 16), HH &= 0xFFFF; O >= 0; offs0 += 8 * 4, --O )
		{

			cl_ulong pCoeff = CD->pCoeff + offs0;
			SET_UADDR(UOffs, VOffs);
			UOffs = (UOffs - CD->pCoeff - DY - DY - 8) + SOffs,
				VOffs = (VOffs - CD->pCoeff) + SOffs;

#define UOld   (pCoeff+VOffs)
#define UData  (pCoeff+UOffs)

#define LOADLINE(pp,E) {    U2##E=*(float4*)(pp);  \
  W2##E=((float4*)(pp))[1];  /*     V2 = a  b  A  B  C  D  E  F */ \
  CC=((float4*)(pp))[2];          /* CC =             G  H  i  j */ \
	prefetch((pp)+DY);\
	AA=vextq<3>(U2##E,W2##E);     /*  B  C  D  E */ \
	U0##E=vextq<2>(U2##E,W2##E);  /*  A  B  C  D */ \
	W0##E=vextq<2>(W2##E,CC);   /* U0 = A  B  C  D  W0= E  F  G  H */ \
	U1##E=vextq<1>(U2##E,W2##E)+AA; /* b  A  B  C + B  C  D  E */ \
	AA=vextq<3>(W2##E,CC); /* F G H i */ \
	W1##E=vextq<1>(W2##E,CC)+AA; /* V1 = bB AC BD CE DF EG FH Gi */ \
	U2##E+=W2##E; W2##E+=CC; }   /* V2 = aC bD AE BF CG DH Ei Fj */
//-end-macro



#define PROCESS(_A,_B,_C,_D,_E)	{  LOADLINE(UData, _E); 	 \
   LDPair(CC,AA,CD->LAPL.s); \
	/* prefetch(pCoeff); prefetch(pCoeff+VOffs); */ \
  U0##_A=fmul<3>( (U0##_A + U0##_E + U2##_C), CC); \
	W0##_A=fmul<3>( (W0##_A + W0##_E + W2##_C) , CC); \
	U0##_A=acc_mul<1>(U0##_A,(U2##_A + U2##_E), AA);\
	W0##_A=acc_mul<1>(W0##_A,(W2##_A + W2##_E), AA); /* U0,W0.##_A=LAPL  36 flops */  \
	U2##_A=fmul<1>((U1##_C + U0##_B + U0##_D), CC);\
	W2##_A=fmul<1>((W1##_C + W0##_B + W0##_D), CC);\
	U0##_A=acc_mul<0>(U0##_A, (U1##_A + U1##_E + U2##_B + U2##_D), AA);\
	W0##_A=acc_mul<0>(W0##_A, (W1##_A + W1##_E + W2##_B + W2##_D), AA);\
	U2##_A=acc_mul<2>(U2##_A, (U1##_B + U1##_D), CC);\
	W2##_A=acc_mul<2>(W2##_A, (W1##_B + W1##_D), CC); /* 20 flops */\
	U0##_A+=U2##_A; W0##_A+=W2##_A; /* U0A = LAPL_SUM */ \
	/* Load coefficients */ \
	W2##_A=vdupq_n_f32(LAP0); /* LAPL[0] */ \
	AAu=*(uint4*)pCoeff;	 LOAD_CA(AAu); \
	U1##_A=CC+AA; AA=CC-AA; (CC+=CC)+=W2##_A; \
	\
	U0##_A=acc_mul(U0##_A, U0##_C,CC); /* 40 flops */ \
  CC=*(float4*)(UOld); \
	U0##_A=nacc_mul(U0##_A, AA,CC); /* 42 flops */ \
  *(float4*)(UOld)=(U0##_A/U1##_A); /* U0 free */ \
	\
	AAu=*(uint4*)(pCoeff+sizeof(AAu));	 LOAD_CA(AAu);\
	U1##_A=CC+AA; AA=CC-AA; (CC+=CC)+=W2##_A; \
	 \
	W0##_A=acc_mul(W0##_A, W0##_C,CC);\
  CC=((float4*)(UOld))[1]; \
	W0##_A=nacc_mul(W0##_A, AA,CC);\
  ((float4*)(UOld))[1]=(W0##_A/=U1##_A); /* U0 free */ \
  pCoeff += DY;	  }
//-end-macro

#define PROCESSLOOP			LOADLINE(UData, A); UOffs += DY;\
			LOADLINE(UData, B); UOffs += DY;		LOADLINE(UData, C); UOffs += DY; \
			LOADLINE(UData, D); UOffs += DY;		LOADLINE(UData, E); \
			for ( int Y = HH; Y > 0; Y -= 5 ) \
			{	PROCESS(A, B, C, D, E);				PROCESS(B, C, D, E, A);\
				PROCESS(C, D, E, A, B);				PROCESS(D, E, A, B, C);\
				PROCESS(E, A, B, C, D);			}
//-end-macro

			PROCESSLOOP
		} // for offset
	} // for src
}// end-kernel


SHADER(ForwardWaveUni, 8, 5)
{
	FWDDECL

#ifdef TARGET_ARM
		union { float4 f; uint4 u; } CCx, AAx;
#else
		float4 CC, AA; uint4 CCu, AAu;
#endif

	int O; 		int HH = H;
	cl_ulong SOffs= (Y0 / CD->InH)*CD->DZ;		Y0 %= CD->InH;
	offset = X0 * 4 + Y0 * CD->DY;

	for ( O = (HH >> 16), HH &= 0xFFFF; O >= 0; offset += 8 * 4, --O )
	{
		cl_ulong pCoeff = CD->pCoeff + offset;
		SET_UADDR(UOffs, VOffs);
		UOffs = (UOffs - CD->pCoeff - DY - DY - 8)+SOffs,
		VOffs = (VOffs - CD->pCoeff) + SOffs;

		PROCESSLOOP
	} // for offset
}// end-kernel


#ifdef TARGET_ARM
#undef AA
#undef AAu
#undef CC
#undef CCu
#endif

#undef UOld
#undef UData
#undef WOld
#undef WData
#undef GData
#undef COMPUTEGRAD

//----------------------------------------
// test - increment all the points
SHADER(Paint, 8, 1)
{

	int O; for ( O = (H >> 16), H &= 0xFFFF; O >= 0; offset += 8 * 4, --O )
	{

		cl_ulong uoffs = CD->pU[2] + offset;
		regs float4 C0, C1;

		for ( int Y = H; Y > 0; --Y )
		{
			//printf(" P=%llX ", uoffs);
			LDPair_(C0, C1, (float*)uoffs); C0 += 1.0f; C1 += 1.0f;
			*(float4*)uoffs = C0; ((float4*)uoffs)[1] = C1;
			uoffs += CD->DY;
		}

	}
}
//----------------------------------------

