#define fshuf4(a,b,c,d,V)  (reinterpret_f(permute4<a,b,c,d>(V)))
#define fblend4(a,b,c,d,V,W)  (reinterpret_f(blend4<a,b,c,d>(V,W)))
#define fshuf8(a,b,c,d,e,f,g,h,V)  (reinterpret_f(permute8<a,b,c,d,e,f,g,h>(V)))
#define fblend8(a,b,c,d,e,f,g,h,V,W)  (reinterpret_f(blend8<a,b,c,d,e,f,g,h>(V,W)))
#define fshuf16(a,b,c,d,e,f,g,h, i,j,k,l,m,n,o,p, V)  (reinterpret_f(permute16<a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p>(V)))
#define fblend16(a,b,c,d,e,f,g,h, i,j,k,l,m,n,o,p, V,W)  (reinterpret_f(blend16<a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p>(V,W)))
#define F4DOWN2(V)   fshuf4(2,3, V_DC,V_DC, V)
#define F8DOWN2(V)   fshuf8(2,3,4,5, 6,7, V_DC,V_DC, V)
#define F16DOWN2(V)  fshuf16(2,3,4,5, 6,7,8,9, 10,11,12,13, 14,15, V_DC,V_DC, V)



#define F16DOWN1(P) P = permute16<1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, V_DC>(P);
#define F8DOWN1(P) P = permute8<1, 2, 3, 4, 5, 6, 7, V_DC>(P);
#define F4DOWN1(P) P = permute4<1, 2, 3, V_DC>(P);


#define LOAD_CA(CCi) 	AA = to_float(CCi >> 16)*CData::A_SCALE; CC = to_float(CCi << 16)*CData::C_SCALE; CC *= CC;
//-end-macro

/*
	data -> a b  A B C D  e f

 V0= A  B  C  D
 V1= bB AC BD Ce
 V2= aC bD Ae Bf

		V0 1 2

 5 4 3 4 5  VA
 4 2 1 2 4  VB
 3 1 0 1 3  VC
 4 2 1 2 4  VD
 5 4 3 4 5  VE
*/

#define UOld   ((float*)(pCoeff+VOffs))
#define UData  ((float*)(pCoeff+UOffs))
#define WOld   ((float*)(pCoeff+ZOffs))
#define WData  ((float*)(pCoeff+WOffs))
#define GData  ((float*)(pCoeff+GOffs))


#define LOADLINE4(pp,qq,E)	{ U2##E.load(pp); W2##E.load(qq);   /* V2 = a  b  A  B  */ \
  CC.load((pp)+4); AA.load((qq)+4);                             /* CC = C  D  e  f  */ \
	U0##E=fblend4(2,3, 4,5, U2##E,CC); \
	W0##E=fblend4(2,3, 4,5, W2##E,AA);                            /* V0 = A  B  C  D  */  \
	U1##E=fblend4(1,2,3, 4, U2##E+U0##E,CC+F4DOWN2(CC));         /* V1 = bB AC BD CE  */ \
	W1##E=fblend4(1,2,3, 4, W2##E+W0##E,AA+F4DOWN2(AA)); \
	U2##E+=CC; W2##E+=AA;  }                                      /* V2 = aC bD AE BF CG DH Ei Fj */
//-end-macro

#define LOADLINE8(pp,qq,E)	{ U2##E.load(pp); W2##E.load(qq);   /* V2 = a  b  A  B  C  D  E  F */ \
  CC.load((pp)+4); AA.load((qq)+4);                             /* CC = C  D  E  F  G  H  i  j */ \
	U0##E=fblend8(2,3,4,5,6,7,  12,13, U2##E,CC); \
	W0##E=fblend8(2,3,4,5,6,7,  12,13, W2##E,AA);                  /* V0 = A  B  C  D  E  F  G  H */  \
	U1##E=fblend8(1,2,3,4, 9,10,11,12, U2##E+U0##E,CC+F8DOWN2(CC));/* V1 = bB AC BD CE DF EG FH Gi */ \
	W1##E=fblend8(1,2,3,4, 9,10,11,12, W2##E+W0##E,AA+F8DOWN2(AA)); \
	U2##E+=CC; W2##E+=AA;  }                                      /* V2 = aC bD AE BF CG DH Ei Fj */
//-end-macro

#define LOADLINE16(pp,qq,E) { U2##E.load(pp); W2##E.load(qq);  /* V2 = a  b  A  B  C  D  E  F */ \
  CC.load((pp)+4); AA.load((qq)+4);                             /* CC = C  D  E  F  G  H  i  j */ \
	U0##E=fblend16(2,3,4,5,6,7, 8,9,10,11,12,13,14,15, 28,29, U2##E,CC); \
	W0##E=fblend16(2,3,4,5,6,7, 8,9,10,11,12,13,14,15, 28,29, W2##E,AA);  /* V0 = A  B  C  D  E  F  G  H */  \
	U1##E=fblend16(1,2,3,4,5,6,7,8,  21,22,23,24,25,26,27,28, U2##E+U0##E, CC+F16DOWN2(CC) );   /* V1 = bB AC BD CE DF EG FH Gi */ \
	W1##E=fblend16(1,2,3,4,5,6,7,8,  21,22,23,24,25,26,27,28, W2##E+W0##E, AA+F16DOWN2(AA) ); \
	U2##E+=CC; W2##E+=AA;  }                 /* V2 = aC bD AE BF CG DH Ei Fj */
//-end-macro



#define LAPL_SUM(_A,_B,_C,_D,_E) CC = CD->LAPL.s[3]; AA = CD->LAPL.s[5]; \
U0##_A = (U0##_A + U0##_E + U2##_C)*CC; \
	(U2##_A +=U2##_E)*=AA;\
  W0##_A =(W0##_A + W0##_E + W2##_C)*CC ;\
	(W2##_A +=W2##_E)*=AA; CC=CD->LAPL.s[1]; AA=CD->LAPL.s[4];\
	U0##_A = mul_add (U1##_C + U0##_B + U0##_D, CC, U0##_A) ;\
	W0##_A = mul_add (W1##_C + W0##_B + W0##_D, CC, W0##_A) ;\
			U2##_A =mul_add(U1##_A + U1##_E + U2##_B + U2##_D, AA, U2##_A); \
			W2##_A =mul_add(W1##_A + W1##_E + W2##_B + W2##_D, AA, W2##_A); \
			U0##_A =mul_add(U1##_B + U1##_D, CD->LAPL.s[2], U0##_A);\
			W0##_A =mul_add(W1##_B + W1##_D, CD->LAPL.s[2], W0##_A);\
			U0##_A+=U2##_A; W0##_A+=W2##_A;
//-end-macro

/////////  BACKWARD WAVE ////////////////////////////////////////////////////


#define COMPUTEGRAD_lowbit(n,n16, _A) add_saturated(((short##n16)CCi), (short##n16)((roundi(U0##_A) & 0x0FFFF) | (roundi(W0##_A) << 16))).store_a(GData); 

#define COMPUTEGRAD(n,n16,_A)    { regs int##n T=0x7FFF;  add_saturated(((short##n16)CCi), (short##n16)( (int##n)((uint##n)(roundi(U0##_A)+T) >>16) | ((roundi(W0##_A)+T) &0xFFFF0000))).store_a(GData); } 

#define BPROCESS(n,n16, _A,_B,_C,_D,_E)	{  LOADLINE##n(UData, WData, _E);  \
      LAPL_SUM(_A,_B,_C,_D,_E) 	/* V0A= L5SUM */  \
			U2##_A.load_a(UOld);  W2##_A.load_a(WOld); \
 			  CCi.load_a((int*)pCoeff);	LOAD_CA(CCi); \
         W1##_A=CC+AA; AA=CC-AA; (CC+=CC)+=CD->LAPL.s[0]; \
         U1##_A = nmul_add(U2##_A, AA, mul_add(U0##_C,CC,U0##_A) ) / W1##_A; /*W*/\
         W1##_A = nmul_add(W2##_A, W1##_A, mul_add(W0##_C,CC,W0##_A) ) / AA; /*U*/\
        CCi.load_a(GData);\
				U1##_A.store_a(UOld);  W1##_A.store_a(WOld); /* U-W NAMES INTERCHANGED */  \
/* 	grad.x += (w0cent.x - Wdest)*(u0cent.x - UDest); */ \
/*	grad.y +=  w0cent.x         * (UOld - UDest); */    \
        U0##_A=(W0##_C-W1##_A)*(U0##_C-U1##_A)*CGScale; \
        W0##_A=(W0##_C)*(U2##_A-U1##_A)*AGScale; \
        COMPUTEGRAD(n,n16,_A);   pCoeff += DY;	 }
//-end-macro



#define BACKWARDWAVE(n,n2) SHADER(BackwardWave, n, 5) \
{	regs float##n U0A, U1A, U2A, U0B, U1B, U2B, U0C, U1C, U2C, U0D, U1D, U2D, U0E, U1E, U2E, CC; \
	regs float##n W0A, W1A, W2A, W0B, W1B, W2B, W0C, W1C, W2C, W0D, W1D, W2D, W0E, W1E, W2E, AA; \
	regs uint##n CCi; \
  float GradMix = (T - CD->EndInvTime) / CD->GradMixDuration; \
  GradMix = CLAMP(GradMix, 0.0f, 1.0f); \
  const float CGScale = CD->CGScale*GradMix, AGScale = CD->AGScale*GradMix; \
	const cl_ulong DY = CD->DY; int O,Src=0; cl_ulong SOffs=0;  \
  for( Src=0; Src<CD->ActiveSrcs; ++Src, SOffs+=CD->DZ ) \
{ /*printf(" src%i ",Src); */  int HH=H; cl_ulong offs0=offset;\
	int O; for ( O = (HH >> 16), HH &= 0xFFFF; O >= 0; offs0 += (n<<2), --O ) \
	{	SET_WADDR(UOffs, VOffs); 		SET_UADDR(WOffs, ZOffs); \
		cl_ulong pCoeff = CD->pCoeff + offs0, GOffs = (CD->pGrad - CD->pCoeff); \
		UOffs = (UOffs - CD->pCoeff - DY - DY - 8) +SOffs; \
		VOffs = (VOffs - CD->pCoeff)+SOffs; \
		WOffs = (WOffs - CD->pCoeff - DY - DY - 8)+SOffs; \
		ZOffs = (ZOffs - CD->pCoeff)+SOffs; \
		LOADLINE##n(UData, WData, A); UOffs += DY; WOffs += DY; \
		LOADLINE##n(UData, WData, B); UOffs += DY; WOffs += DY; \
		LOADLINE##n(UData, WData, C); UOffs += DY; WOffs += DY; \
		LOADLINE##n(UData, WData, D); UOffs += DY; WOffs += DY; \
		for ( int Y = HH; Y > 0; Y -= 5 ) \
		{	BPROCESS(n, n2, A, B, C, D, E); \
			BPROCESS(n, n2, B, C, D, E, A); \
			BPROCESS(n, n2, C, D, E, A, B); \
			BPROCESS(n, n2, D, E, A, B, C); \
			BPROCESS(n, n2, E, A, B, C, D); \
		}		\
	}}/* offset */ \
}//fn
//-end-macro

BACKWARDWAVE(4, 8);
BACKWARDWAVE(8, 16);
BACKWARDWAVE(16, 32);

#undef BPROCESS
#undef BACKWARDWAVE
#undef COMPUTEGRAD

/////////  FORWARD WAVE /////////////////////////////////////////////////////






#define FPROCESS(n, _A,_B,_C,_D,_E)	{ LOADLINE##n(UData, WData, _E);  \
       LAPL_SUM(_A,_B,_C,_D,_E) \
				CCi.load_a((int*)pCoeff); LOAD_CA(CCi);	\
          U1##_A=CC+AA; AA=CC-AA; (CC+=CC)+=CD->LAPL.s[0]; \
				  U2##_A.load_a(UOld); \
			  CCi.load_a((int*)(pCoeff+sizeof(CCi)));	\
		    U1##_A = nmul_add(U2##_A, AA, mul_add(U0##_C,CC,U0##_A)  ) / U1##_A; /* V1=UWnew, V0 free */\
				LOAD_CA(CCi);	\
          W2##_A.load_a(WOld);\
          W1##_A=CC+AA; AA=CC-AA; (CC+=CC)+=CD->LAPL.s[0]; \
        W1##_A = nmul_add(W2##_A, AA, mul_add(W0##_C,CC,W0##_A) ) / W1##_A; /* V1=UWnew, V0 free */\
				U1##_A.store_a(UOld);  W1##_A.store_a(WOld); \
	    pCoeff += CD->DY;	   }
//-end-macro


#undef WData
#undef WOld
#define WData ((float*)(pCoeff+UOffs+V))
#define WOld  ((float*)(pCoeff+VOffs+V))

#define FORWARDWAVE(n) SHADER(ForwardWave, n+n, 5) \
{	regs float##n U0A, U1A, U2A, U0B, U1B, U2B, U0C, U1C, U2C, U0D, U1D, U2D, U0E, U1E, U2E, CC;\
  regs float##n W0A, W1A, W2A, W0B, W1B, W2B, W0C, W1C, W2C, W0D, W1D, W2D, W0E, W1E, W2E, AA;\
  regs uint##n CCi; constexpr int V=n*4;\
	int O,Src=0; cl_ulong SOffs=0;  \
  for( Src=0; Src<CD->ActiveSrcs; ++Src, SOffs+=CD->DZ ) \
{ /*printf(" src%i ",Src); */  int HH=H; cl_ulong offs0=offset;\
  for ( O =(HH >> 16), HH &= 0xFFFF; O >= 0; offs0+= (n<<3),--O ) \
	{	SET_UADDR(UOffs, VOffs); \
		cl_ulong pCoeff = CD->pCoeff + offs0; \
		UOffs = (UOffs - CD->pCoeff - CD->DY - CD->DY - 8) +SOffs; \
		VOffs = (VOffs - CD->pCoeff) +SOffs; \
		LOADLINE##n(UData, WData, A); UOffs += CD->DY; \
    LOADLINE##n(UData, WData, B); UOffs += CD->DY; \
		LOADLINE##n(UData, WData, C); UOffs += CD->DY; \
		LOADLINE##n(UData, WData, D); UOffs += CD->DY; \
		for ( int Y = HH; Y > 0; Y -= 5 ) \
		{	FPROCESS(n, A, B, C, D, E); \
			FPROCESS(n, B, C, D, E, A); \
			FPROCESS(n, C, D, E, A, B); \
			FPROCESS(n, D, E, A, B, C); \
			FPROCESS(n, E, A, B, C, D); \
		}	\
	}}/* offset */ \
}//fn
//-end-macro

FORWARDWAVE(4);
FORWARDWAVE(8);
FORWARDWAVE(16);

#undef FORWARDWAVE

#define FORWARDWAVE(n) SHADER(ForwardWaveUni, (n)+(n), 5) \
{	regs float##n U0A, U1A, U2A, U0B, U1B, U2B, U0C, U1C, U2C, U0D, U1D, U2D, U0E, U1E, U2E, CC;\
  regs float##n W0A, W1A, W2A, W0B, W1B, W2B, W0C, W1C, W2C, W0D, W1D, W2D, W0E, W1E, W2E, AA;\
  regs uint##n CCi; constexpr int V=n*4;\
	int O; 		int HH = H; \
  cl_ulong SOffs = (Y0 / CD->InH)*CD->DZ;		Y0 %= CD->InH; \
  offset = X0 * 4 + Y0 * CD->DY; \
  for ( O = (HH >> 16), HH &= 0xFFFF; O >= 0; offset += (V*2), --O ) \
  {	SET_UADDR(UOffs, VOffs); \
    cl_ulong pCoeff = CD->pCoeff + offset; \
    UOffs = (UOffs - CD->pCoeff - CD->DY - CD->DY - 8) + SOffs; \
    VOffs = (VOffs - CD->pCoeff) + SOffs; \
    LOADLINE##n(UData, WData, A); UOffs += CD->DY; \
    LOADLINE##n(UData, WData, B); UOffs += CD->DY; \
		LOADLINE##n(UData, WData, C); UOffs += CD->DY; \
		LOADLINE##n(UData, WData, D); UOffs += CD->DY; \
		for ( int Y = HH; Y > 0; Y -= 5 ) \
		{	FPROCESS(n, A, B, C, D, E); \
			FPROCESS(n, B, C, D, E, A); \
			FPROCESS(n, C, D, E, A, B); \
			FPROCESS(n, D, E, A, B, C); \
			FPROCESS(n, E, A, B, C, D); \
		}	\
	}/* offset */ \
}//fn
//-end-macro

FORWARDWAVE(4);
FORWARDWAVE(8);
FORWARDWAVE(16);

#undef FPROCESS
#undef FORWARDWAVE
#undef LOADLINE8
#undef LOADLINE16

// test - increment all the points
SHADER(Paint, 16, 1)
{
	int O; for ( O = (H >> 16), H &= 0xFFFF; O >= 0; offset += 16 * 4, --O )
	{
		cl_ulong uoffs = CD->pU[2] + offset;
		regs float16 CC;
		for ( int Y = H; Y > 0; --Y )
		{	//printf(" P=%llX ", uoffs);
			CC.load((float*)uoffs); CC += 1.0f; CC.store((float*)uoffs);
			uoffs += CD->DY;
		}
	}
}

//----------------------------------------

#undef LOAD_CA
#undef SET_UADDR
#undef SET_WADDR

